;==============================================================================
;
; MSX X^[tH[X eҏW
;
;==============================================================================
macro	PUBLBL, name
public	name
name:
endm
macro	PUBDEF, name, value
public	name
name	equ	value
endm

macro	mPutText, tx, adr
	ld		hl,tx
	ld		de,adr
	call	put_str
endm


is_enemy_x_no_fixed	equ	#ee56
def_game_config_0	equ	00000011b


;================================================================
;	L[
;================================================================
PUBLBL	get_key
PROC
		call	get_sticktrig
		ret		nz
		call	#009c
		ld		a,0
		ret		z
		call	#009f
		or		a
		ret
ENDP

PUBLBL	get_sticktrig
PROC
		ld		a,#6
		call	#0141
		bit		5,a
		jr		nz,_not_f1
		ld		a,#20
		or		a
		ret
	_not_f1:

		ld		a,2
	_lp:
		push	af
		add		a,3
		call	#00d8
		or		a
		ld		a,#1b
		jr		nz,_ret_nz
		pop		af
if	0					; blueMSX̘A˃^[{OFF߂ǂ̂ŁAgK1ĝ͂
		push	af
		call	#00d8
		or		a
		ld		a,#20
		jr		nz,_ret_nz
		pop		af
endif
		push	af
		call	#00d5
		inc		a
		rra
		ld		h,_stick_tbl>>8
		add		a,_stick_tbl&#ff
		ld		l,a
		ld		a,(hl)
		or		a
		jr		nz, _ret_nz
		pop		af

		dec		a
		jp		p,_lp
		xor		a
		ret

	_ret_nz:
		pop		bc
		or		a
		ret

	_stick_tbl:
		db		0,#1e,#1c,#1f,#1d
ENDP

;================================================================
;	ҏWnp[^
;================================================================
PUBLBL	init_editor_values
PROC
		xor		a
		ld		(#ee10),a	; current bank no
		ld		(#ee11),a	; main menu cursor
		ld		(#ee12),a	; bullet cursor
		ld		(#ee13),a	; bg cursor
		ld		(#ee14),a	; palette cursor
		ld		(#ee15),a	; game cfg cursor

		call	load_sram
		ret		z

		; load default
		; color_palette_tbl
		ld		hl,color_palette_tbl
		ld		de,#ee30
		ld		bc,#20
		ldir
		; bullet_color
		ld		hl,bullet_color_tbl
		ld		de,#ee00
		ld		bc,#0010
		ldir
		; bg_color_tbl
		ld		hl,bg_color_tbl
		ld		de,#ee20
		ld		bc,colors_of_bg
		ldir

		ld		a,def_game_config_0
		ld		(is_enemy_x_no_fixed),a

		ret
ENDP


;================================================================
;	wiFXV
;================================================================
bgc_base	equ		#94d4
PUBLBL	update_bg_color_all
PROC
		call	update_bg_color
		jp		update_bg_color_postproc
ENDP

PUBLBL	update_bg_color
PROC
		di

		ld		hl,bgc_base+8*top_of_rocks
		ld		de,#2000+8*top_of_rocks
		ld		bc,8*num_of_rocks
		exx
		ld		hl,bg_color_tbl
		ld		de,#ee20+colors_of_rocks-1
		ld		bc,colors_of_rocks
		exx
		call	update_bg_color_sub

		ld		hl,bgc_base+8*top_of_walls
		ld		de,#2000+8*top_of_walls
		ld		bc,8*num_of_walls
		exx
		ld		hl,bg_color_tbl+colors_of_rocks
		ld		de,#ee20+colors_of_rocks+colors_of_walls-1
		ld		bc,colors_of_walls
		exx
		call	update_bg_color_sub

		ld		hl,bgc_base+8*top_of_panes
		ld		de,#2000+8*top_of_panes
		ld		bc,8*num_of_panes
		exx
		ld		hl,bg_color_tbl+colors_of_rocks+colors_of_walls
		ld		de,#ee20+colors_of_rocks+colors_of_walls+colors_of_panes-1
		ld		bc,colors_of_panes
		exx
		call	update_bg_color_sub

		ei
		ret
ENDP

update_bg_color_sub:
PROC
		push	bc
		call	set_vram_adr_de
		pop		de

		ld		b,e
		dec		de
		inc		d
		ld		e,b
	_lpL:
		ld		a,(hl)

		exx
		call	update_bg_color_sub_sub
		ld		b,a
		exx

		ld		a,(hl)
		rra
		rra
		rra
		rra

		exx
		call	update_bg_color_sub_sub
		rla
		rla
		rla
		rla
		and		#f0
		or		b
		exx

		out		(c),a
		inc		hl
		dec		e
		jr		nz,_lpL
		dec		d
		jr		nz,_lpL

		ret
ENDP

update_bg_color_sub_sub:
PROC
		push	hl
		push	de
		push	bc
		and		#f
		ld		b,0
		cpir
		jr		nz,_ret
		ex		de,hl
		xor		a
		sbc		hl,bc
		ld		a,(hl)
	_ret:
		pop		bc
		pop		de
		pop		hl
		ret
ENDP

; PCGJ[e[üiڂSiɃRs[
PUBLBL	update_bg_color_postproc
PROC
		di
		ld		hl,#2000
		ld		de,#2800
		ld		bc,#0800
		call	vcopy

		ld		hl,#2000
		ld		de,#3000
		ld		bc,#0800
		call	vcopy

		ld		hl,#2000
		ld		de,#3800
		ld		bc,#0800
		call	vcopy
		ei
		ret
ENDP

;================================================================
;	pbgXV
;================================================================
PUBLBL	update_color_palette
PROC
		di
		ld		hl,#ee30
		call	change_color_palette
		ei
		ret
ENDP

;================================================================
;	ҏW[h؂ւ
;================================================================
editor_setup:
PROC
		; ʃNA
		call	cls
		call	key_off_wait
		ret
ENDP

editor_close:
PROC
		call	cls
		call	dumb_loop
		call	key_off_wait
		ld		a,#ff
		ret
ENDP

; ʃNA
cls:
		di
		xor		a
		ld		hl,#4020
		ld		bc,#03e0
		call	di_0056
		xor		a
		ld		hl,#4800
		ld		bc,#0400
		call	di_0056
		ei
		ret

key_off_wait:
PROC
		call	get_key
		jr		nz,key_off_wait
		ret
ENDP

dumb_loop:
PROC
		ld		bc,0
	_lp:
		cpi
		cpd
		ret		po
		jr		_lp
ENDP


;================================================================
;	j[[h
;================================================================
PUBLBL	menu_mode
PROC
		di
		; sprite display stop
		; XvCg\~
		;ld		hl,#880a
		;out		(c),l
		;out		(c),h
		ld		hl,#e680
		ld		a,(hl)
		ld		(#ee1f),a
		ld		a,(#ee51)
		neg
		add		a,#d0
		ld		(hl),a

		ei

		call	main_menu

		di
		call	save_sram

		; sprite display resume
		; XvCg\ĊJ
		;ld		hl,#8808
		;out		(c),l
		;out		(c),h
		ld		a,(#ee1f)
		ld		(#e680),a

		; resume display
		; BGItZbgLĕ\XV
		ld		a,(#ee52)
		inc		a
		ld		(#ee52),a

		ei
		ret
ENDP


PUBLBL	main_menu
PROC
		call	editor_setup

		mPutText	tx_menu_0, #00a3
		mPutText	tx_menu_1, #00e3
		mPutText	tx_menu_2, #0123
		mPutText	tx_menu_3, #0163
		mPutText	tx_menu_4, #01a3
		mPutText	tx_menu_5, #01e3
		mPutText	tx_menu_6, #0223

		jr		_key_off_wait

	_main_loop:
		call	get_key
		jr		z,_main_loop
		cp		#1b
		jp		z, _exit

		ld		hl,#ee11

		cp		#1e
		jr		nz,_not_up
		ld		a,(hl)
		dec		a
		jp		p,_not_top
		add		a,#07
	_not_top:
		ld		(hl),a
		jr		_key_off_wait
	_not_up:
		cp		#1f
		jr		nz,_not_down
		ld		a,(hl)
		inc		a
		cp		#07
		jr		c,_not_bottom
		xor		a
	_not_bottom:
		ld		(hl),a
		jr		_key_off_wait
	_not_down:
		cp		'0'
		jr		c,_not_number
		cp		'6'+1
		jr		nc,_not_number
		sub		'0'
		jr		_submenu
	_not_number:
		cp		#20
		jr		nz,_key_off_wait
		ld		a,(hl)
		jr		_submenu

	_key_off_wait:
		call	_update_disp
		call	key_off_wait
		jr		_main_loop

	_exit:
		jp		editor_close

	_update_disp:
		ld		de,#00a1
		ld		b,7
	_update_disp_loop:
		ld		hl,#ee11
		ld		a,7
		sub		b
		cp		(hl)
		ld		hl,tx_cursor
		jr		z,_put_cursor
		ld		hl,tx_space
	_put_cursor:
		call	put_str
		ld		a,#40
		call	add_de_a
		djnz	_update_disp_loop
		ret

	_submenu:
		or		a
		jr		z,_exit

		ld		hl,_ret
		push	hl

		dec		a
		jp		z,game_config_editor
		dec		a
		jp		z,enemy_bullet_editor
		dec		a
		jp		z,bg_color_editor
		dec		a
		jp		z,color_palette_editor
		dec		a
		jp		z,tape_save
		dec		a
		jp		z,tape_load

		pop		hl
	_ret:
		jp		main_menu
ENDP


;================================================================
;	Q[ݒҏW[h
;================================================================
PUBLBL	game_config_editor
PROC
		call	editor_setup

		mPutText	tx_gamecfg_0, #00a3
		mPutText	tx_gamecfg_1, #00e3
		mPutText	tx_gamecfg_2, #0123

		ld		a,(#ee15)

		jr		_key_off_wait

	_main_loop:
		call	get_key
		jr		z,_main_loop
		cp		#1b
		jp		z, _exit

		ld		hl,#ee15

		cp		#1e
		jr		nz,_not_up
		ld		a,(hl)
		dec		a
		jp		p,_not_top
		add		a,#03
	_not_top:
		ld		(hl),a
		jr		_key_off_wait
	_not_up:
		cp		#1f
		jr		nz,_not_down
		ld		a,(hl)
		inc		a
		cp		#03
		jr		c,_not_bottom
		xor		a
	_not_bottom:
		ld		(hl),a
		jr		_key_off_wait
	_not_down:
		cp		#20
		jr		nz,_key_off_wait
		ld		a,(hl)
		or		a
		jr		z,_exit
		ld		b,1
		dec		a
		jr		z,_sw_gamecfg
		sla		b
		dec		a
		jr		z,_sw_gamecfg
	_key_off_wait:
		call	_update_disp
		call	key_off_wait
		jr		_main_loop

	_exit:
		jp		editor_close

	_sw_gamecfg:
		ld		a,(is_enemy_x_no_fixed)
		xor		b
		ld		(is_enemy_x_no_fixed),a
		jr		_key_off_wait

	_update_disp:
		ld		de,#00a1
		ld		b,3
	_update_disp_loop:
		ld		hl,#ee15
		ld		a,3
		sub		b
		cp		(hl)
		ld		hl,tx_cursor
		jr		z,_put_cursor
		ld		hl,tx_space
	_put_cursor:
		call	put_str
		ld		a,#40
		call	add_de_a
		djnz	_update_disp_loop

		ld		de,#00f4
		ld		a,(is_enemy_x_no_fixed)
		bit		0,a
		ld		hl,tx_gamecfg_1_0
		jr		z,_put_gamecfg_1
		ld		hl,tx_gamecfg_1_1
	_put_gamecfg_1:
		call	put_str

		ld		de,#0134
		ld		a,(is_enemy_x_no_fixed)
		bit		1,a
		ld		hl,tx_gamecfg_2_0
		jr		z,_put_gamecfg_2
		ld		hl,tx_gamecfg_2_1
	_put_gamecfg_2:
		call	put_str
		ret
ENDP


;================================================================
;	GeFҏW[h
;================================================================
PUBLBL	enemy_bullet_editor
PROC
		call	editor_setup
		call	setup_color_sample

		jr		_key_off_wait

	_main_loop:
		call	get_key
		jr		z,_main_loop
		cp		#1b
		jp		z, _exit

		ld		hl,#ee12

		cp		#1e
		jr		nz,_not_up
		ld		a,(hl)
		dec		a
		and		#f
		ld		(hl),a
		jr		_key_off_wait
	_not_up:
		cp		#1f
		jr		nz,_not_down
		ld		a,(hl)
		inc		a
		and		#f
		ld		(hl),a
		jr		_key_off_wait
	_not_down:
		cp		#1c
		jr		nz,_not_right
		ld		l,(hl)
		ld		a,(hl)
		inc		a
		and		#f
		ld		(hl),a
		jr		_key_off_wait
	_not_right:
		cp		#1d
		jr		nz,_not_left
		ld		l,(hl)
		ld		a,(hl)
		dec		a
		and		#f
		ld		(hl),a
		jr		_key_off_wait
	_not_left:
		cp		'0'
		jr		c,_not_0_9
		cp		'9'+1
		jr		nc,_not_0_9
		sub		'0'
		jr		_0_9_A_Z
	_not_0_9:
		cp		'a'
		jr		c,_main_loop
		cp		'f'+1
		jr		nc,_main_loop
		sub		'a'-10
		jr		_0_9_A_Z
	_not_a_z:
		cp		'A'
		jr		c,_main_loop
		cp		'F'+1
		jr		nc,_main_loop
		sub		'A'-10
	_0_9_A_Z:
		ld		l,(hl)
		ld		(hl),a
	_key_off_wait:
		call	update_enemy_bullet_editor
		call	key_off_wait
		jr		_main_loop

	_exit:
		call	release_color_sample
		jp		editor_close
ENDP




;==============================================================================
;	GeFҏW[h\
;==============================================================================
update_enemy_bullet_editor:
PROC
		ld		hl,tx_menu_2+2
		ld		de,#0064
		call	put_str

		ld		hl,tx_eb_header
		ld		de,#00aa
		call	put_str

		ld		de,#00ca
		ld		b,#10
	_loop:
		ld		a,#10
		sub		b
		ld		c,a

		ld		a,(#ee12)
		cp		c
		ld		hl,tx_cursor
		jr		z,_put_cursor
		ld		hl,tx_space
	_put_cursor:
		call	put_str

		inc		de
		inc		de

		ld		a,c
		call	put_number
		
		ld		a,5
		call	add_de_a

		ld		h,#ee
		ld		l,c
		ld		a,(hl)
		call	put_color_name

		ld		a,#20-2-5
		call	add_de_a
		djnz	_loop

		ret
ENDP




;================================================================
;	wiFҏW[h
;================================================================
PUBLBL	bg_color_editor
PROC
		call	editor_setup
		call	setup_color_sample

		di

		ld		hl,(#f3c7)	; name table
		ld		a,l
		add		a,#40
		ld		l,a
		call	set_vram_adr_hl
		call	put_pcg_list

		ld		hl,tx_bge_lb0
		ld		de,#00e6
		ld		b,colors_of_bg
	_list_label:
		call	put_str
		ld		a,#6
		call	add_hl_a
		ld		a,#20
		call	add_de_a
		djnz	_list_label

		ei

		jr		_key_off_wait

	_main_loop:
		call	get_key
		jr		z,_main_loop
		cp		#1b
		jr		z,_exit

		ld		hl,#ee13

		cp		#1e
		jr		nz,_not_up
		ld		a,(hl)
		or		a
		jr		nz,_not_top
		ld		a,colors_of_bg
	_not_top:
		dec		a
		ld		(hl),a
		jr		_key_off_wait
	_not_up:
		cp		#1f
		jr		nz,_not_down
		ld		a,(hl)
		inc		a
		cp		colors_of_bg
		jr		nz,_not_btm
		xor		a
	_not_btm:
		ld		(hl),a
		jr		_key_off_wait
	_not_down:
		cp		#1c
		jr		nz,_not_right
		call	get_current_bg_color
		inc		a
		jr		_update
	_not_right:
		cp		#1d
		jr		nz,_not_left
		call	get_current_bg_color
		dec		a
		jr		_update
	_not_left:
		cp		'0'
		jr		c,_not_0_9
		cp		'9'+1
		jr		nc,_not_0_9
		sub		'0'
		jr		_0_9_A_Z
	_not_0_9:
		cp		'a'
		jr		c,_main_loop
		cp		'f'+1
		jr		nc,_main_loop
		sub		'a'-10
		jr		_0_9_A_Z
	_not_a_z:
		cp		'A'
		jr		c,_main_loop
		cp		'F'+1
		jr		nc,_main_loop
		sub		'A'-10
	_0_9_A_Z:
		push	af
		call	get_current_bg_color
		pop		af
	_update:
		and		#f
		ld		(hl),a
		call	update_bg_color
	_key_off_wait:
		call	update_bg_color_editor
		call	key_off_wait
		jr		_main_loop

	_exit:
		call	release_color_sample
		call	update_bg_color_postproc
		jp		editor_close
ENDP


get_current_bg_color:
PROC
		ld		hl,#ee13
		ld		a,(hl)
		add		a,#20
		ld		l,a
		ld		a,(hl)
		ret
ENDP

update_bg_color_editor:
PROC
		ld		de,#00e4
		ld		bc,colors_of_bg*256

		di
	_loop:
		ld		a,(#ee13)
		cp		c
		ld		hl,tx_cursor
		jr		z,_put_cursor
		ld		hl,tx_space
	_put_cursor:
		call	put_str

		ld		a,#0a
		call	add_de_a

		ld		a,c
		ld		hl,#ee20
		call	add_hl_a
		ld		a,(hl)
		call	put_color_name

		ld		a,#20-#0a
		call	add_de_a
		inc		c
		djnz	_loop

		ei
		ret
ENDP


;================================================================
;	J[pbgҏW[h
;================================================================
PUBLBL	color_palette_editor
PROC
		call	editor_setup
		call	setup_color_sample

		di

		ld		hl,(#f3c7)	; name table
		ld		a,l
		add		a,#40
		ld		l,a
		call	set_vram_adr_hl
		call	put_pcg_list

		ld		hl,tx_paled_lb0
		ld		de,#00e8
		call	put_str

		ld		hl,tx_c0
		ld		de,#0108
		ld		b,#10
	_list_label:
		call	put_str
		ld		a,#5
		call	add_hl_a
		ld		a,#20
		call	add_de_a
		djnz	_list_label

		ei

		jp		_key_off_wait

	_main_loop:
		call	get_key
		jr		z,_main_loop
		cp		#1b
		jp		z,_exit

		ld		hl,#ee14

		cp		#1e
		jr		nz,_not_up
		ld		a,(hl)
		sub		3
		jr		_chk_move
	_not_up:
		cp		#1f
		jr		nz,_not_down
		ld		a,(hl)
		add		a,3
		jr		_chk_move
	_not_down:
		cp		#1c
		jr		nz,_not_right
		ld		a,(hl)
		inc		a
		jr		_chk_move
	_not_right:
		cp		#1d
		jr		nz,_not_left
		ld		a,(hl)
		dec		a
	_chk_move:
		cp		#30
		jr		c,_move
		add		a,#30
		jr		c,_move
		sub		#60
	_move:
		ld		(hl),a
		jr		_key_off_wait
	_not_left:

		cp		#20
		jr		nz,_not_space
		ld		a,(hl)
		call	palette_cursor_pos_to_hl_a
		call	palette_value_at_hl_a
		dec		a
		and		#7
		jr		_set_color
	_not_space:
		cp		'z'
		jr		nz,_not_z_key
		ld		a,(hl)
		call	palette_cursor_pos_to_hl_a
		call	palette_value_at_hl_a
		inc		a
		and		#7
		jr		_set_color
	_not_z_key:
		cp		'0'
		jr		c,_key_off_wait
		cp		'7'+1
		jr		nc,_key_off_wait
		sub		'0'
	_set_color:
		ld		b,a
		ld		a,(#ee14)
		call	palette_cursor_pos_to_hl_a
		or		a
		jr		z,_setR
		dec		a
		jr		z,_setB
	_setG
		ld		(hl),b
		jr		_update
	_setB:
		ld		a,(hl)
		and		#f0
		or		b
		ld		(hl),a
		jr		_update
	_setR:
		ld		a,(hl)
		and		#f
		sla		b
		sla		b
		sla		b
		sla		b
		or		b
		ld		(hl),a
	_update:
		call	update_color_palette
	_key_off_wait:
		call	update_color_palette_editor
		call	key_off_wait
		jp		_main_loop

	_exit:
		call	release_color_sample
		jp		editor_close
ENDP


;================================================================
;	J[pbgҏW[h\
;================================================================
update_color_palette_editor:
PROC
		ld		de,#0111
		ld		b,#30
		ld		c,#00
	_loop:
		ld		a,c
		call	palette_cursor_pos_to_hl_a
		push	af
		call	palette_value_at_hl_a
		call	put_number

		ld		a,(#ee14)
		cp		c
		ld		hl,tx_cursor
		jr		z,_put_cursor
		ld		hl,tx_space
	_put_cursor:
		call	put_str

		pop		af
		cp		#2
		ld		a,#2
		jr		nz,_isNotG
		ld		a,#20-2-2
	_isNotG:
		call	add_de_a

		inc		c
		djnz	_loop

		ret
ENDP


palette_cursor_pos_to_hl_a:		; hl:adr of rg or b. a:0=r,1=g,2=b
PROC
		ld		hl,#ee30-2
	_div3:
		inc		hl
		inc		hl
		sub		#3
		jr		nc,_div3
		add		a,#3
		cp		#2
		ret		nz
		inc		hl
		ret
ENDP

palette_value_at_hl_a:			; hl:adr of rg or b. a:0=r,1=g,2=b
PROC
		or		a
		ld		a,(hl)
		jr		nz,_notR
		rra
		rra
		rra
		rra
	_notR:
		and		#f
		ret
ENDP


;==============================================================================
;	F{쐬
;==============================================================================
setup_color_sample:
PROC
		ld		hl,#2000+8*224
		ld		b,3
	_lpP:
		di
		call	set_vram_adr_hl
		push	bc
		ld		b,#10
	_lpC:
		push	bc
		ld		a,#10
		sub		b
		ld		b,a
		add		a,a
		add		a,a
		add		a,a
		add		a,a
		add		a,b
		ld		b,8
	_lp8:
		out		(c),a
		djnz	_lp8
		pop		bc
		djnz	_lpC
		ei
		ld		bc,#800
		add		hl,bc
		pop		bc
		djnz	_lpP
		ret
ENDP

;	F{J
release_color_sample:
PROC
		ld		hl,bgc_base+8*224
		ld		de,#2000+8*224
		ld		bc,8*16
		di
		call	di_005c
		ei
		ld		hl,bgc_base+8*224
		ld		de,#2800+8*224
		ld		bc,8*16
		di
		call	di_005c
		ei
		ld		hl,bgc_base+8*224
		ld		de,#3000+8*224
		ld		bc,8*16
		di
		call	di_005c
		ei
		ret
ENDP


;==============================================================================
;	PCGx^
;==============================================================================
put_pcg_list:
PROC
		ld		b,#80
		xor		a
	_lp:
		out		(c),a
		inc		a
		djnz	_lp
		ret
ENDP


;==============================================================================
;	F̏o	a:color code de:vram ofs
;==============================================================================
put_color_name:
PROC
		push	hl
		ld		l,a
		add		a,a
		add		a,a
		add		a,l
		ld		hl,tx_c0
		call	add_hl_a
		call	put_str
		pop		hl
		ret
ENDP

;==============================================================================
;	l̏o	a:0-9a-f de:vram ofs
;==============================================================================
put_number:
PROC
		push	bc
		ld		c,a
		add		a,a
		add		a,c
		ld		hl,tx_0
		call	add_hl_a
		call	put_str
		pop		bc
		ret
ENDP



;================================================================
;	sramǂݍ
;================================================================
check_sram:
		ld		hl,#8639
		ld		(#8000),hl
check_sram_initialized:
		ld		hl,(#8000)
		ld		de,#8639
		xor		a
		sbc		hl,de
		ret

PUBLBL	load_sram
PROC
		ld		a,#f0
		ld		(#7000),a

		call	check_sram_initialized
		jr		z,_load

		ld		hl,#8010

		; high score
		xor		a
		ld		(hl),a
		inc		hl
		ld		(hl),a
		inc		hl
		ld		(hl),a
		inc		hl

		ex		de,hl
		; color_palette_tbl
		ld		hl,color_palette_tbl
		ld		bc,#20
		ldir
		; bullet_color
		ld		hl,bullet_color_tbl
		ld		bc,#0010
		ldir
		; bg_color_tbl
		ld		hl,bg_color_tbl
		ld		bc,colors_of_bg
		ldir
		ld		a,def_game_config_0
		ld		(de),a
		inc		de

	_load:
		call	check_sram
		jr		nz,_exit_load_sram

		ld		hl,#8010
		; high score
		ld		de,#e3d5
		ld		bc,3
		ldir
		; color_palette_tbl
		ld		de,#ee30
		ld		bc,#20
		ldir
		; bullet_color
		ld		de,#ee00
		ld		bc,#0010
		ldir
		; bg_color_tbl
		ld		de,#ee20
		ld		bc,#0010
		ldir
		; 
		ld		de,is_enemy_x_no_fixed
		ld		bc,#0001
		ldir

		xor		a
	_exit_load_sram:
		ld		a,2
		ld		(#7000),a
		ret
ENDP


;================================================================
;	sramɕۑ
;================================================================
PUBLBL	save_sram
PROC
		ld		a,#f0
		ld		(#7000),a

		call	check_sram
		jr		nz,_exit_save_sram

		ld		de,#8010
		; high score
		ld		hl,#e3d5
		ld		bc,3
		ldir
		; color_palette_tbl
		ld		hl,#ee30
		ld		bc,#20
		ldir
		; bullet_color
		ld		hl,#ee00
		ld		bc,#0010
		ldir
		; bg_color_tbl
		ld		hl,#ee20
		ld		bc,#0010
		ldir
		;
		ld		hl,is_enemy_x_no_fixed
		ld		bc,#0001
		ldir

		xor		a
	_exit_save_sram:
		ld		a,2
		ld		(#7000),a
		ret
ENDP


PUBLBL	save_high_score
PROC
		ld		a,#f0
		ld		(#7000),a

		call	check_sram
		jr		nz,_exit_save_high_score

		ld		de,#8010
		; high score
		ld		hl,#e3d5
		ld		bc,3
		ldir

		xor		a
	_exit_save_high_score:
		ld		a,2
		ld		(#7000),a
		ret
ENDP


;================================================================
;	e[vǂݍ
;================================================================
PUBLBL	tape_load
PROC
		call	editor_setup

		ld		hl,tx_tape_r
		ld		de,#0146
		call	put_str

		call	#00e1
		jr		c,_err_o

		ld		c,0

		ld		hl,#ee00
		ld		b,#10
		call	tape_load_sub
		jr		c,_err_r

		ld		hl,#ee20
		ld		b,#10
		call	tape_load_sub
		jr		c,_err_r

		ld		hl,#e3d5
		ld		b,#3
		call	tape_load_sub
		jr		c,_err_r

		ld		hl,#ee30
		ld		b,#20
		call	tape_load_sub
		jr		c,_err_r

		ld		hl,is_enemy_x_no_fixed
		ld		b,#1
		call	tape_load_sub
		jr		c,_err_r

		exx
		call	#00e4
		exx
		jr		c,_err_r
		cp		c
		jr		nz,_err_r

	_end:
		call	#00e7
		call	update_bg_color_all
		call	update_color_palette
		jp		editor_close

	_err_o:
		ld		hl,tx_tape_eo
		jr		_err
	_err_r:
		ld		hl,tx_tape_er
	_err:
		ld		de,#0168
		call	put_str
		jp		_end
ENDP


tape_load_sub:
PROC
	_lp:
		exx
		call	#00e4
		ret		c
		exx
		ld		(hl),a
		add		a,c
		ld		c,a
		inc		l
		djnz	_lp
		xor		a
		ret
ENDP

;================================================================
;	e[vۑ
;================================================================
PUBLBL	tape_save
PROC
		call	editor_setup

		ld		hl,tx_tape_w
		ld		de,#0146
		call	put_str

		call	#00ea
		jr		c,_err_o

		ld		c,0

		ld		hl,#ee00
		ld		b,#10
		call	tape_save_sub
		jr		c,_err_w

		ld		hl,#ee20
		ld		b,#10
		call	tape_save_sub
		jr		c,_err_w

		ld		hl,#e3d5
		ld		b,#3
		call	tape_save_sub
		jr		c,_err_w

		ld		hl,#ee30
		ld		b,#20
		call	tape_save_sub
		jr		c,_err_w

		ld		hl,is_enemy_x_no_fixed
		ld		b,#1
		call	tape_save_sub
		jr		c,_err_w

		ld		a,c
		exx
		call	#00ed
		exx
		jr		c,_err_w

	_end:
		call	#00f0
		jp		editor_close

	_err_o:
		ld		hl,tx_tape_eo
		jr		_err
	_err_w:
		ld		hl,tx_tape_ew
	_err:
		ld		de,#0168
		call	put_str
		jp		_end
ENDP


tape_save_sub:
PROC
	_lp:
		ld		a,(hl)
		add		a,c
		ld		c,a
		ld		a,(hl)
		exx
		call	#00ed
		ret		c
		exx
		inc		l
		djnz	_lp
		xor		a
		ret
ENDP




;==============================================================================
;	
;==============================================================================
tx_eb_header:	db	"FRAME@@COLOR",#FF

tx_space:	db	"@",#FF
tx_cursor:	db	"?",#FF

tx_0:	db	"00",#FF
tx_1:	db	"01",#FF
tx_2:	db	"02",#FF
tx_3:	db	"03",#FF
tx_4:	db	"04",#FF
tx_5:	db	"05",#FF
tx_6:	db	"06",#FF
tx_7:	db	"07",#FF
tx_8:	db	"08",#FF
tx_9:	db	"09",#FF
tx_A:	db	"10",#FF
tx_B:	db	"11",#FF
tx_C:	db	"12",#FF
tx_D:	db	"13",#FF
tx_E:	db	"14",#FF
tx_F:	db	"15",#FF

tx_c0:	db	"0;``",#FF
tx_c1:	db	"1;aa",#FF
tx_c2:	db	"2;bb",#FF
tx_c3:	db	"3;cc",#FF
tx_c4:	db	"4;dd",#FF
tx_c5:	db	"5;ee",#FF
tx_c6:	db	"6;ff",#FF
tx_c7:	db	"7;gg",#FF
tx_c8:	db	"8;hh",#FF
tx_c9:	db	"9;ii",#FF
tx_cA:	db	"A;jj",#FF
tx_cB:	db	"B;kk",#FF
tx_cC:	db	"C;ll",#FF
tx_cD:	db	"D;mm",#FF
tx_cE:	db	"E;nn",#FF
tx_cF:	db	"F;oo",#FF

PUBDEF	colors_of_rocks	,2
PUBDEF	colors_of_walls	,5
PUBDEF	colors_of_panes	,7
PUBDEF	colors_of_bg	,colors_of_rocks+colors_of_walls+colors_of_panes
PUBDEF	top_of_rocks	,1
PUBDEF	num_of_rocks	,28
PUBDEF	top_of_walls	,top_of_rocks+num_of_rocks
PUBDEF	num_of_walls	,67
PUBDEF	top_of_panes	,top_of_walls+num_of_walls
PUBDEF	num_of_panes	,28
tx_bge_lb0:	db	"ROCK0",#FF
tx_bge_lb1:	db	"ROCK1",#FF
tx_bge_lb2:	db	"WALL0",#FF
tx_bge_lb3:	db	"WALL1",#FF
tx_bge_lb4:	db	"WALL2",#FF
tx_bge_lb5:	db	"WALL3",#FF
tx_bge_lb6:	db	"WALL4",#FF
tx_bge_lb7:	db	"PANE0",#FF
tx_bge_lb8:	db	"PANE1",#FF
tx_bge_lb9:	db	"PANE2",#FF
tx_bge_lbA:	db	"PANE3",#FF
tx_bge_lbB:	db	"PANE4",#FF
tx_bge_lbC:	db	"PANE5",#FF
tx_bge_lbD:	db	"PANE6",#FF

tx_paled_lb0:	db	"PALETTE@@@R@G@B",#FF

tx_tape_r:	db	"@@LOAD@FROM@TAPE@@",#FF
tx_tape_w:	db	"@@SAVE@TO@TAPE@@",#FF
tx_tape_eo:	db	"@@OPEN@ERROR@@",#FF
tx_tape_ew:	db	"@@WRITE@ERROR@@",#FF
tx_tape_er:	db	"@@READ@ERROR@@",#FF

tx_menu_0:	db	"0;EXIT",#FF
tx_menu_1:	db	"1;GAME@CONFIG",#FF
tx_menu_2:	db	"2;ENEMY@BULLET@COLOR CONFIG",#FF
tx_menu_3:	db	"3;BG@COLOR@CONFIG",#FF
tx_menu_4:	db	"4;COLOR@PALETTE@CONFIG",#FF
tx_menu_5:	db	"5;TAPE@SAVE",#FF
tx_menu_6:	db	"6;TAPE@LOAD",#FF

tx_gamecfg_0:	db	"EXIT",#FF
tx_gamecfg_1:	db	"HORZ@SCROLL;",#FF
tx_gamecfg_2:	db	"ADJUST@INIT@POS;",#FF
tx_gamecfg_1_0:	db	"BG@ONLY@@@@",#FF
tx_gamecfg_1_1:	db	"SPRITES@TOO",#FF
tx_gamecfg_2_0:	db	"NO@",#FF
tx_gamecfg_2_1:	db	"YES",#FF
