;==============================================================================
;
; MSX X^[tH[X
;
;	^Cg
;
;==============================================================================
public	put_title
put_title:
proc
		push	af
		ld		hl,color_palette_tbl
		call	change_color_palette
		pop		af

		and		#0f
	_lp:
		sub		0+(put_title_msx-_title_routines)/2
		jr		nc,_lp
		add		a,0+(put_title_msx-_title_routines)/2

		ld		hl,_title_routines
		add		a,a
		add		a,l
		ld		l,a
		ld		a,(hl)
		inc		hl
		ld		h,(hl)
		ld		l,a
		jp		(hl)

	_title_routines:
		dw		put_title_msx, put_title_fc, put_title_nes, put_title_sc3000, put_title_arcade, put_title_megaforce
endp

macro	mPutTitle, _pcgAdr, _pcgSize, _nameSize, _nameOfs
		ld		hl,_pcgAdr
		ld		bc,_pcgSize
		call	write_title_pcg_ptn
		ld		de,_nameOfs
		ld		bc,_nameSize
		jr		put_title_pcg_name
endm

put_title_msx:
		mPutTitle	title_msx_pcg, #0168, 32*9, #0040
put_title_fc:
		mPutTitle	title_fc_pcg, #0280, 32*10, #0040
put_title_nes:
		mPutTitle	title_nes_pcg, #0400, 32*6, #0040
put_title_sc3000:
		mPutTitle	title_sc3000_pcg, #02a8, 32*6, #0060

put_title_arcade:
		ld		hl,title_arcade_lze
		jr		put_title_sc5
put_title_megaforce:
		ld		hl,title_megaforce_lze
		jr		put_title_sc5


put_title_pcg_name:
		push	hl
		ld		hl,(#f3c7)
		add		hl,de
		ex		de,hl
		pop		hl
		jp		di_005c

write_title_pcg_ptn:
proc
		ld		de,(#f3cb)
		push	hl
		push	de
		push	bc
		call	_write_title_pcg_sub
		pop		bc
		pop		de
		pop		hl
		ld		a,d
		add		a,#08
		ld		d,a
	_write_title_pcg_sub:
		push	de
		push	bc
		call	di_005c
		pop		bc
		pop		de
		ld		a,d
		add		a,#20
		ld		d,a
		call	di_005c
		ret
endp

put_title_sc5:
proc
		push	hl
		ld		hl,#4000
		ld		bc,#300
		xor		a
		call	di_0056
		ld		hl,#8000
		ld		bc,128*128
		xor		a
		call	di_0056
		pop		hl

		; page1-1BANK6
		ld		a,6
		ld		(#6800),a

		ld		de,#8810
		ld		b,#40
	_lp_lze:
		push	bc

		push	de
		ld		de,#e000
		call	DECODE_LZE
		pop		de

		push	hl
		call	set_vram_adr_de
		ld		hl,#e000
		ld		b,#60
		otir
		ld		a,#80
		call	add_de_a
		pop		hl

		pop		bc
		djnz	_lp_lze

		;pbgf[^Rs[
		ld		de,#e000
		ld		bc,#20
		ldir

		; page1-1BANK1ɖ߂
		ld		a,1
		ld		(#6800),a

	_init_hkeyi:
		ld		hl,hkeyi_title_arcade
		ld		de,#e020
		ld		bc,end_hkeyi_title_arcade-hkeyi_title_arcade
		ldir

		di
		;HTIMIZbg
		ld		a,#c3
		ld		(#fd9a),a
		ld		hl,#e020
		ld		(#fd9a+1),hl

		;VDPo̓|[g擾
		ld		a,(#0007)
		inc		a
		ld		c,a

		;HSYNCCԍZbg
		ld		hl,#9300+64+16
		out		(c),l
		out		(c),h

        ret
endp

; org	#e020Ƃ
hkeyi_title_arcade:
proc
		ld		hl,#0006
		ld		b,(hl)
		inc		b
		inc		l
		ld		c,(hl)
		inc		c

		;HSYNC`FbN
		ld		hl,#8f01
		out		(c),l
		out		(c),h
		ld		a,c
		ld		c,b
		in		d,(c)
		ld		c,a

		;Xe[^XWX^0ZNg
		xor		a
		out		(c),a
		out		(c),h

		;sprite off
		ld		hl,#880a
		out		(c),l
		out		(c),h

		;scroll
		ld		hl,#9700
		out		(c),l
		out		(c),h

		rrc		d
		jr		c,_hsync
	;A荞
	_vblank:
		;screen5
        ld		hl,#8000+#16
		ld		de,#8200+#3f	; name #8000h
		out		(c),l
		out		(c),h
		out		(c),e
		out		(c),d
		;palette
		ld		hl,#e000
		jp		change_color_palette

	;荞
	_hsync:
		;``
		push	bc
		ld		hl,#e020+_null_pallet-hkeyi_title_arcade
		call	change_color_palette
		pop		bc
		;screen2
        ld		hl,#8000+#12
		ld		de,#8200+#10	; name #4000h
		out		(c),l
		out		(c),h
		out		(c),e
		out		(c),d
		;palette
		ld		hl,color_palette_tbl
		jp		change_color_palette
	_null_pallet:
		ds		#20
endp
end_hkeyi_title_arcade:


;================================================
;//	LZE DECODE ROUTINE
;//	Original Copyright (C)1995,2008 GORRY.
;//	Porting for Z80 by Kei Moroboshi 2017/SEP.
;================================================
include	"StarForce-lzdec.mac"


;================================================
; title data
;================================================
title_msx_pcg:
incbin	"StarForce-title-msx.dat"

title_fc_pcg:
incbin	"StarForce-title-fc.dat"

title_nes_pcg:
incbin	"StarForce-title-nes.dat"

title_sc3000_pcg:
incbin	"StarForce-title-sc3000.dat"

title_arcade_lze:
incbin	"StarForce-title-arcade_192x64.lze"

title_megaforce_lze:
incbin	"StarForce-title-megaforce_192x64.lze"
